require 'gitlab'

module Mooset
  module Endpoints
    class Gitlab < Endpoint

      attribute :endpoint, String
      attribute :private_token, String
      attribute :connection, Object, default: Proc.new { |gitlab, attribute|
        ::Gitlab.client({
          endpoint: "#{gitlab.endpoint}/api/v3/",
          private_token: gitlab.private_token,
        })
      }
      attribute :provider, String, default: 'ldapmain'

      resource :users do
        UserSearch.new(self)
      end

      resource :groups do
        GroupSearch.new(self)
      end
    end
  end
end
