module Mooset
  module Endpoints
    class Ldap
      class Group < Models::Group
        attribute :dn, String
        attribute :provider, String, default: "ldap"
        finders [:dn, :name]

        def self.build(endpoint, params)
          group = Optional.new(params)
          new(
            endpoint: endpoint,
            id: group[:dn].first.value,
            dn: group[:dn].first.value,
            name: group[:cn].first.value
          )
        end

        def members
          endpoint.users.find(memberof: id)
        end
      end
    end
  end
end
