module Mooset
  class Model
    include Virtus.model

    attr_reader :endpoint
    lspace_reader :logger

    def self.finders(finder_list)
      define_method :finders do
        finder_list
      end
    end

    def initialize(*args)
      hash = args[0] || {}
      @endpoint = hash.delete(:endpoint)

      super(*args)
    end

    def to_json(*args)
      attributes.to_json
    end

    def finders
      []
    end

    def to_s
      "#{self.class.name.split('::').last}[#{provider}]"
    end
  end
end
