module Mooset
  class SynchronizeGroup
    attr_accessor :from, :to, :opts

    def initialize(from, to, opts)
      @from = from
      @to = to
      @opts = opts
    end

    def call
      @from.groups.find(@opts[:query]).each do |group|
        to_group = @to.groups.find(group)

        if !to_group
          to_group = @to.groups.import(group)
        end

        to_member_ids = to_group.members.map(&:id)

        group.members.each do |user|
          #next unless user.id =~ /Alexandru/
          next if @opts[:skip] && @opts[:skip].any? { |o| user.username == o }

          to_user = @to.users.find(user)

          if !to_user
            to_user = @to.users.import(user)
          end

          to_group << to_user unless to_member_ids.include?(to_user.id)
        end
      end
    end
  end
end
